<?php
/**
* @package	Joomla
* @subpackage	plg_vergeembedlyplugin
* @copyright	Copyright (C) 2010 Verge Studios. All rights reserved.
* @license	GNU/GPL - http://www.gnu.org/copyleft/gpl.html
* @author 	Max Neuvians [vergegraphics.com]
* @version 	0.9
* Joomla! and plg_vergeembedlyplugin are free software. This version may have been
* modified pursuant to the GNU General Public License, and as distributed they
* include or are derivative of works licensed under the GNU General Public
* License or other free or open source software licenses.
*/

// No direct access allowed to this file
defined( '_JEXEC' ) or die( 'Restricted access' );
 
// Import Joomla! Plugin library file
jimport('joomla.plugin.plugin');

class plgContentVergeembedlyplugin extends JPlugin
{
        function plgContentVergeembedlyplugin( &$subject, $params )
        {
                parent::__construct( $subject, $params );
                
        }

        function onPrepareContent(&$row, &$params, $limitstart)
        {
                global $mainframe;

                if ( !preg_match("#\[embedly\]#s", $row->text) && !preg_match("#\[/embedly\]#s", $row->text) ) {
                        return;
                }
                
                $plugin =& JPluginHelper::getPlugin('content', 'vergeembedlyplugin');
                $pluginParams = new JParameter( $plugin->params );
                
                $document = &JFactory::getDocument();
                $document->addScript( 'http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js');
                $document->addScript( 'http://scripts.embed.ly/jquery.embedly.js' );
                
                $javascript .= "jQuery.noConflict();";
                
                
                $javascript .= "var embedly_maxWidth = ".($pluginParams->get("maxWidth") != "" ? $pluginParams->get("maxWidth") : "''").";\n";
                $javascript .= "var embedly_maxHeight = ".($pluginParams->get("maxHeight") != "" ? $pluginParams->get("maxHeight") : "''").";\n";
                $javascript .= "var embedly_method = '".$pluginParams->get("method")."';\n";
                $javascript .= "var embedly_wrapElement = '".($pluginParams->get("wrapElement") != "" ? $pluginParams->get("wrapElement") : "div")."';\n";
                $javascript .= "var embedly_className = '".($pluginParams->get("className") != "" ? $pluginParams->get("className") : "embed")."';\n";
                $javascript .= "var embedly_addImageStyles = ".($pluginParams->get("addImageStyles") ? "true" : "false").";\n";
                $javascript .= "var embedly_cssSelector = 'a".($pluginParams->get("cssSelector") != "" ? ".".$pluginParams->get("cssSelector") : "")."';\n";
                $javascript .= "var embedly_not_cssSelector = '".($pluginParams->get("not_cssSelector") != "" ? ".".$pluginParams->get("not_cssSelector") : "")."';\n";
                $javascript .= "var embedly_urlRe = ".($pluginParams->get("urlRe") != "" ? $pluginParams->get("urlRe") : "''").";\n";
                
                
                $document->addScriptDeclaration($javascript);
                
                preg_match_all("#\[embedly](.+?)\[/embedly]#s",$row->text, $regs, PREG_SET_ORDER  );
                
                foreach($regs AS $key => $instance):
                        if($instance[1] != ''):
                                $vars = explode("|",$instance[1]);
                                $row->text = str_replace($instance[0],"<a href='".$instance[1]."' id='embedly_link_id"."_".$key."' class='".($pluginParams->get("cssSelector") != "" ? $pluginParams->get("cssSelector") : "embedly_link")."'>".$vars[0]."</a>",$row->text);
                                echo "<script type='text/javascript'>jQuery(document).ready(function(){jQuery('#embedly_link_id"."_".$key."').embedly({maxWidth: ".($vars[1] != "" ? $vars[1] : ($pluginParams->get("maxWidth") != "" ? $pluginParams->get("maxWidth") : "''")).", maxHeight:".($vars[2] != "" ? $vars[2] : ($pluginParams->get("maxHeight") != "" ? $pluginParams->get("maxHeight") : "''"))."});});</script>";
                        endif;
                endforeach;
        }

}
